.comment   To prepare this file for help purposes use
.comment   scope edit to load the following macro:
.comment
.comment      findnext eol backspace delword delword beginline ^D
.comment
.comment   **help**
.comment   then load a search pattern of "**help**" and execute the 
.comment   macro (ESC * ^E) for the whole file.
.comment
.comment   Also the files SCCTRL.HLP, SCOKEY.HLP, and SCH19.HLP
.comment   must be created seperately.
.comment
.comment   Finally, the file SCDEFS.RNO should be adjusted accordingly.
.comment
.include scdefs.rno
.rm rightmargin
.lm leftmargin
.ps papersize,64
.f
.comment **help**
.t VTEDIT IN TED
.comment **help**
.centre; SCOPE EDITING IN TED
.comment **help**
.centre; --------------------
.s 1
 Screen editing in TED is entered with the  'VT'  command.   The
 'VT'  command  will  place  the  user into a free format screen
 editor which is controlled  exclusively  by  the  use  of  control
 characters  (letters typed with the CTRL key on) and by the use of
 certain  escape  sequences  generated  by  the  arrow   and   'PF'
 (Programmed Function) keys.  
.comment **help** .i -leftmargin; *SWITCHES

.s 1
 The VT command has associated  with  it  several  command  line
 switches.  They are as follows:
.s 1
.nf
  /NOL   'nolinenumbers' Do not print line numbers out
  /LIN   'linenumbers'   Print line numbers (default)
  /VT52  say our terminal is a DEC VT52
  /VT100 say our terminal is a DEC VT100 (the default)
  /ANSI  say our terminal is an  ansi standard crt
  /PAG:n Start initial page at line 'n', not at line 1
  /PDEL  enable normal rubout key movement.
  /FIL:n set fill line length to value in 'n'
  /WRAP  enable auto line wraparound for kb input
  /PRI   change line insertion method.
  /LMA:n sets the left margin to 'n'

.f 
Note:
.S 1
The WRAP and NOWRAP control the action taken when the left margin
is reached when in input mode 
(automatic upon typing a carriage return).
If 'wrap' is set (see control V) then a carriage return is automatically
inserted and the current line broken at the last word in the line when
the line length reaches the right fill margin (see '/FILL:nn'). This
allows the continuous typing of text without having to watch for the
right margin overflowing, useful in document preparation.
The usual control of this is by typing _^V, waiting for the 'SET>'
prompt and then typing WRAP to enable or NOWRAP to disable autowrap.
.s 2
The FILL:value sets the right fill margin used by the keypad command
'fill' (Gold 4) and by the 'WRAP' option. The value given can be in the
range 2 to 130 (roughly). See 'Control V' below for setting the fill
once in the scope editor. The default fill is 'FILL:72'.
.s 2
KED mode is the default and only needs to be set (via control V) if for
some reason the VT100 loses the special keypad mode (as would happen on
power up if you tripped over your power cord, etc...).
.s 3
.comment **help** .i -leftmargin; *CONTROL FUNCTIONS
.i -5; CONTROL FUNCTIONS:
.BR
.comment **help** .i -leftmargin; _@EDRT:SCCTRL.HLP
.include SCCTRL.RNO
.comment **help** .i -leftmargin; *HELP
.i -5; HELP
.s 1
 A short help text can be printed by typing escape H or GOLD H.
.s 2
.comment **help** .i -leftmargin; *LINE INSERTION
.i -5; LINE INSERTION MODE:
.s 1
 Line insert  mode is entered automatically  by typing  a carriage
 return,  line feed or form feed (_^L).  The screen will be blanked
 from  the line to be inserted down to the end of the page on a VT52
 or VT52 compatable terminal, while on a VT100 or ANSI terminal a
 blank line will simply appear and the rest of the text will then
 scroll down one line on the screen.  Insert mode
 is terminated by typing a  control Z (_^Z) instead of a <cr>
 to finish  off a line.  Insert mode  is also terminated by typing
 control A, control B, control C, control D, control N,  control T
 or the up arrow, down arrow, or the PF1, PF2, PF3 and PF4 keys (BLUE,
 RED, GRAY, and f1 keys on a H19).
.s 1
 The left arrow, right arrow and rubout keys will  continue to operate
 normally in this mode.
 The other defined control characters (E, F, G, H, P, R, U, W,
 X, and backspace) will operate normally.
 In general, any escape or control sequence  that would  cause the
 current line to move will terminate the line insert mode.
.s 1
The control V set commands 'WRAP', 'NOWRAP' and 'FILL:decvalue'
alter the way insertion mode works for text entry. If 'WRAP' is
set (see above under switches) then a line break is done automatically
when the fill margin is reached, which defaults to 72. NOWRAP will
disable this feature and is the default. 'WRAP' is useful for
documentation entry and a disaster for program entry!
.s 1
As an alternative to the blanking of the screen and sticking in
'insert' mode, the parameter 'PRINT' can be set by either using
control V or GOLD M. This, when set, will cause a cr/lf simply to
start a new line ala VTEDIT or EDT style.
.COMMENT **help**
.page
.comment **help** .i -leftmargin; *CURSOR CONTROL
.i -5; CURSOR POSITION CONTROL:
.s 1
 The two cursor  movement keys left arrow and right arrow are used
 to  control  the character position within the current line. They
 can be used at any time while in the 'VT'  command,  including
 during line insertion mode. The up and down arrow keys  cause the
 current line to change, thus these two would cause early termination
 of an active insert mode.
 The 'backspace'  key will cause a toggle between the start of the
 current line and the end of that line.
 Control F (_^F) will move the cursor to the next word in the line,  and
 control R (_^R) will move back to the previous  word.  A 'word'
 is defined to be anything delimited by a space or tab.
.s 2
.comment **help** .i -leftmargin; *PAGE CONTROL
.i -5; PAGE CONTROL:
.s 1
 In addition to  the control B and control T  functions, the  'PF'
 function keys PF2 (or RED on an H19), control P (_^P) and PF1+PF2 
 (BLUE+RED on an H19) cause, respectively, a move to
 the next page, a reprint of the current page,  and a move to  the
 previous page.  These keys  also will  terminate any  active line
 insertions.
.s 2
.comment **help** .i -leftmargin; *RUBOUT
.i -5; THE RUBOUT KEY:
.s 1
 The RUBOUT key can be used at any time to erase characters in the
 current line,  including when in  line insertion  mode. It is not
 possible to rubout  line terminators  like carriage  returns. The
 rubout key normally will hold the cursor position while deleteing
 characters, and will move left only when the  end of the  line is
 reached. This can be changed by using the /PDEL switch on  the
 the command line, or via the control V ('SET')  command once  you
 are in the scope editor.
.s 2
.comment **help** .i -leftmargin; *PF KEYS

.i -5; The 'PF' (programable function) keys:
.s 1
 PF1####-##(escape#P) 'GOLD' key (acts like SHIFT in
 ##########KEYPAD editing)
.s 1
 PF2####-##(escape#Q) displays the next page of text.
.s 1
 PF1+PF2-##(Gold+PF2) displays the previous page of
 ##########text.
.s 1
 PF3####-##(escape#R) find the next occurance of a
 ##########previously entered search pattern (see '7').
.s 1
 PF1+PF3-##(Gold+PF3) find the next occurance of a
 ##########prompted for search pattern (see Gold 7).
.s 1
 PF4####-##(escape#S) deletes the current line of
 ##########text.
.s 1
 PF1+PF4-##(Gold+PF4) undelete the last line deleted.
.s 2
.comment **help** .i -leftmargin; *REPEAT COUNTS
.i -5; SETTING REPEAT COUNTS (GOLD DIGITS):
.s 1
 All keypad commands (except NEXT LINE "0") can be repeated from
 one to 999 times by setting a repeat count with the command sequence
 GOLD (which is PF1 on a VT100 or BLUE on a H19) followed by a
 string of 1 to 3 digits. The numbers
 will be echoed on the last line of the display. The entering of this
 repeat count is stopped by typing anything other than a rubout or a
 digit. The 'repeat count' is one-shot, it is ALWAYS cleared after each
 control character or KEYPAD command. It is also cleared if anything
 other than a command is typed after setting the repeat count.
 This is also used for SPSINS, in which case the value is converted
 to the ascii representation and placed into the current line.
 A repeat count of '*' (typed GOLD *) is an infinite count, except
 for DELLINE (PF4 or _^D) in which case all lines to the end of the
 page are deleted.

.s 2
.comment **help** .i -leftmargin; *SAVE AREAS
.i -5; ALTERNATE SAVE AREAS:
.s 1
 The control G and control W commands can  retrieve and  get text
 from save areas other than the default by preceding the  command
 with the same type of 'Gold digit' sequence as described above.
 The only difference is that the allowable range is 1 thru 6.
.comment **help** .i -leftmargin; *KEYPAD
.INCLUDE SCOKEY.RNO
.BR
.comment **help** .i -leftmargin; _@EDRT:SCOKEY.HLP
.ST AUTOMATIC TERMINATION OF MACROS
.comment **help** .i -leftmargin;
.X AUTOMATIC TERMINATION OF MACROS
.s 2
.comment **help** .i -leftmargin; *MACROS
.i -5; MACROS
.s 1
Macros, entered via _^X and invoked by _^E (or GOLD digit _^E)
will be automatically terminated under the following conditions.
.nf

        A next line would cause a movement past eof.
        A previous line would move to line 0 (?).
        A find next (PF3) fails.
        A delete (_^D) reaches the end of the file.

.f
This is done in order that the user can specify a large repeat
count, which is done by typing GOLD digit or GOLD * immediately
preceding the typing of _^E.
.s 2
.comment **help**
.ST SPECIAL MATCH CONTROL CONSTRUCTS
.comment **help**
.page
.comment **help**
.X SPECIAL MATCH CONTROL CONSTRUCTS
.comment **help** .i -leftmargin; *MATCHING

.s 1
The FINDNEXT command (PF3 on a VT100 or GRAY on a H19)
 and the REPLACE command (ENTER or _^N)
allow the use of special match control character sequences to allow
matches on character classes. The patterns are the same as in TECO
and are as follows:
.NF

Note: The 'uparrow letter'  sequence is entered by typing the
      Uparrow key (shift 6) followed by the letter. Note that
      _^E can be also be entered by typing CTRL E.


        _^X        matches any character
        _^S        Accepts any non alpha-numeric
        _^Ea       accepts any alphabetic (A-Z,a-z)
        _^Ec       accepts A-Z,a-z,0-9,.,$
        _^Ed       accepts any digit 0-9
        _^Er       accepts any upper case letter or
                   any digit 0-9.
        _^Es       accepts any space or tab
        _^Ev       matches any lowercase letter
        _^Ew       matches any uppercase letter
        _^Ex       same as _^X
        _^E_<nnn>   accepts the character whose ASCII
                   code (in octal) is nnn.
        _^Q        uses the next character literally,
                   included to allow searches for
                   things like uparrows.
        _^R        same as _^Q

For example, to find a _<linefeed>_<carriage return>
sequence, enter the search pattern (via 'SETPAT'
(GOLD enter)) as:

        _^E_<12>_^E_<15>

and then type FINDNEXT.
.comment **help**
.ST ASCII CHART (IN OCTAL AND DECIMAL)
.comment **help**
.PAGE
.comment **help** .i -leftmargin; *ASCII CHART
.X ASCII CHART (IN OCTAL AND DECIMAL)
.LM 0
.nf
 ASCII CHART

  CHAR DEC OCT   CHAR DEC OCT   CHAR DEC OCT   CHAR DEC OCT
  
   _NUL   0   0     _SP  32  40     _@   64 100     _`   96 140
   _^A    1   1     _!   33  41     _A   65 101     _a   97 141
   _^B    2   2     _"   34  42     _B   66 102     _b   98 142
   _^C    3   3     _#   35  43     _C   67 103     _c   99 143
   _^D    4   4     _$   36  44     _D   68 104     _d  100 144
   _^E    5   5     _%   37  45     _E   69 105     _d  101 145
   _^F    6   6     _&   38  46     _F   70 106     _f  102 146
   _BEL   7   7     _'   39  47     _G   71 107     _g  103 147
   _BKSP  8  10     _(   40  50     _H   72 110     _h  104 150
   _TAB   9  11     _)   41  51     _I   73 111     _i  105 151
   _LF   10  12     _*   42  52     _J   74 112     _j  106 152
   _VT   11  13     _+   43  53     _K   75 113     _k  107 153
   _FF   12  14     _,   44  54     _L   76 114     _l  108 154
   _CR   13  15     _-   45  55     _M   77 115     _m  109 155
   _^N   14  16     _.   46  56     _N   78 116     _n  110 156
   _^O   15  17     _/   47  57     _O   79 117     _o  111 157
   _^P   16  20     _0   48  60     _P   80 120     _p  112 160
   _XON  17  21     _1   49  61     _Q   81 121     _q  113 161
   _^R   18  22     _2   50  62     _R   82 122     _r  114 162
   _XOFF 19  23     _3   51  63     _S   83 123     _s  115 163
   _^T   20  24     _4   52  64     _T   84 124     _t  116 164
   _^U   21  25     _5   53  65     _U   85 125     _u  117 165
   _^V   22  26     _6   54  66     _V   86 126     _v  118 166
   _^W   23  27     _7   55  67     _W   87 127     _w  119 167
   _^X   24  30     _8   56  70     _X   88 130     _x  120 170
   _^Y   25  31     _9   57  71     _Y   89 131     _y  121 171
   _^Z   26  32     _:   58  72     _Z   90 132     _z  122 172
   _ESC  27  33     _;   59  73     _[   91 133     _{  123 173
   _FS   28  34     _<   60  74     _\   92 134     _|  124 174
   _GS   29  35     _=   61  75     _]   93 135     _}  125 175
   _RS   30  36     _>   62  76     _^   94 136     _~  126 176
   _US   31  37     _?   63  77     __   95 137    DEL 127 177
.f
.lm LEFTMARGIN
.COMMENT **help**
.st USING SCOPE WITH AN H19
.comment **help** .i -leftmargin; *H19
.page
.comment **help** .i -leftmargin; _@EDRT:SCH19.HLP
.include SCH19.RNO
